{CADBOXES as of 30.10.1998. (C)1998 by Bernhard Knibbe

This Component is a enhanced listbox/combobox like seen on a famous cad program.
 Its rather useful to visualize/change/check boolean values related to stringlists.
It is originally based on the SKDLIST.ZIP by robert@alpine.net
You can add up to 8 "toggle" bitmaps,stored in a TImageList.
The indexes of the TImageList correspond to the index of the flags:
0    shown whenever a flag is false
1..8 shown in the corresponding column if the flag is true
The flags of an item are stored as a byte in the loword of an attached object.
With double clicking on any of the bitmaps, you can change their status.

I know this description sucks ;-). Just test out by yourself.

****************************
New properties:
***************
Imagelist:Holds the bitmaps. The bitmap with index zero (0) will
          be seen if the according flag is set to false.
          Image 1..Image 7 are the images of the according flags.
          Note, that if property ShowEmptyFlags=false you wont see Bitmap Index 0!

FlagCount:Here you select the number of toggle buttons (0..8). If this value is bigger
          than the maximum Imagelist index you wont see pictures there.

ShowEmptyFlag:See above

ToggleFlags:If set to false you cant change the flags with the mouse

New Events:
***********
OnFlagClick:Whenever you click on a bitmap, it toggles and this event is fired.

New Procedures/functions:
*************************
procedure AddEntry:Use this if you want to set an item and the flags at the same time
                   If you use items.add(..) the value of the flags is not predictable

function GetFlag(Index:integer;FlagNumber:byte):boolean
         Get the flag status of the given index.

procedure SetFlag(Index:integer;Flagnumber:byte;Flag:boolean);
          Sets one single flag within the tstrings object.

For further details look into the code. Just go down!

****************************
To use the component:
*********************
Drop a TImageList and fill it with bitmaps (do not use too big ones)
Drop the CadListBox and fill the Imagelist property.
Fill the Itemheight property according to the size of the bitmaps and your taste.
Add strings programmatically with the AddEntry-procedure or via items.add(..).
Check/Change the flags of the strings with the mouse or with Get/Setflag.
Thats it.
*****************************

(p)1998 by Bernhard Knibbe.

History:

1.0 16.10.98: Basic functionality implemented.
              Originally released to the public domain.

1.1 Bugs removed:
         The left two images were always the same. Sorry for that!
         Exception caused by not assigning a TImageList at designtime
         Not assigning a TImageList will cause the Component to work as
         a normal List/Combo box
    New property:
         ToggleFlags (boolean): if set to false you cant do much with your mouse

    Added an example for easy understanding
    Improved documentation
    CadListBox and CadComboBox put into one file
    Improved handling of bigger fonts, but still not 100% satisfying.
    (As a workaround, double font.size and enter this value as ItemHeight with the CadComboBox)

This components are freeware.

If you like/use/dont like/misuse it just drop me a line
Thanks to all who offer free components to the Public Domain!

Bernhard Knibbe
Vienna, Austria
b_knibbe@csi.com
http://ourworld.compuserve.com/homepages/b_knibbe
Please report any bugs/problems/improvements!
}

unit CadBoxes;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, DsgnIntf, StdCtrls;

type TFlagClickEvent=procedure(Sender:Tobject;Index:integer;FlagNumber:byte;Flag:boolean) of object;

     TCadListBox = class(TListBox)
  private
    FShowEmptyFlag:boolean;
    fToggleFlags:boolean;
    FFlagCount:byte;
    FMargin:byte;
    FImageIndex : Integer;
    FimageList : TImageList;
    FCadListBox : TCadListBox;
    FOnFlagClick:TFlagClickEvent;
    Function GetImageList : TImageList;
    Procedure SetImageList(Value : TImageList);
    Function GetImageIndex : Integer;
    Procedure DrawImage(Index, NewIndex : Integer; Rect: TRect);
    procedure SetFlagCount(AFlagCount:byte);
    procedure SetMargin(AMargin:byte);
    Procedure SetEmptyFlag(AFlag:boolean);
  protected
    procedure MouseDown(Button: TMouseButton;Shift: TShiftState; X, Y: Integer); override;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    Procedure DrawItem(Index: Integer; Rect: TRect; State: TOwnerDrawState);  override;
    Function AddEntry(s:string;flag:byte):integer;
    Property NewImageIndex : Integer read FImageIndex write FImageIndex stored True;

    published
    property ImageList : TImageList read GetImageList write SetImageList stored True;
    Property FlagCount:byte read FFlagCount write SetFlagCount Stored True;
    Property Margin:byte read FMargin write SetMargin Stored True;
    Property ShowEmptyFlag:boolean read fShowEmptyFlag write SetEmptyFlag stored True;
    Property OnFlagClick:TFlagClickEvent read fOnFlagClick write fOnFlagClick;
    Function GetFlag(Index:integer;FlagNumber:byte):boolean;
    Procedure SetFlag(Index:integer;FlagNumber:byte;Flag:Boolean);
    property ToggleFlags:boolean read fToggleFlags write fToggleFlags;
  end;

     TCadComboBox = class(TComboBox)
  private
    FShowEmptyFlag:boolean;
    fToggleFlags:boolean;
    FFlagCount:byte;
    FMargin:byte;
    FImageIndex : Integer;
    FimageList : TImageList;
    FCadComboBox : TCadComboBox;
    FOnFlagClick:TFlagClickEvent;
    Function GetImageList : TImageList;
    Procedure SetImageList(Value : TImageList);
    Function GetImageIndex : Integer;
    Procedure DrawImage(Index, NewIndex : Integer; Rect: TRect);
    procedure SetFlagCount(AFlagCount:byte);
    procedure SetMargin(AMargin:byte);
    Procedure SetEmptyFlag(AFlag:boolean);
  protected
    procedure MouseDown(Button: TMouseButton;Shift: TShiftState; X, Y: Integer); override;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    Procedure DrawItem(Index: Integer; Rect: TRect; State: TOwnerDrawState);  override;
    Function AddEntry(s:string;flag:byte):integer;
    Property NewImageIndex : Integer read FImageIndex write FImageIndex stored True;

    published
    property ImageList : TImageList read GetImageList write SetImageList stored True;
    Property FlagCount:byte read FFlagCount write SetFlagCount Stored True;
    Property Margin:byte read FMargin write SetMargin Stored True;
    Property ShowEmptyFlag:boolean read fShowEmptyFlag write SetEmptyFlag stored True;
    Property OnFlagClick:TFlagClickEvent read fOnFlagClick write fOnFlagClick;
    Function GetFlag(Index:integer;FlagNumber:byte):boolean;
    Procedure SetFlag(Index:integer;FlagNumber:byte;Flag:Boolean);
    property ToggleFlags:boolean read fToggleFlags write fToggleFlags;
  end;


procedure Register;

implementation

{Checking for a bit}
function test(input,which:byte):byte;
begin
 if input and (1 shl (which)) = 0 then test:=0 else test:=1;
end;

{************************CADLISTBOX code starts here************************}
{Adding a new item and a set of flags}
Function TCadListBox.AddEntry(s:string;flag:byte):integer;
begin
Items.addobject(s,TObject(makelong(flag,0)));
end;

procedure TCadListBox.SetFlagCount(AFlagCount:byte);
begin
if AFlagCount<9 then if AFlagCount<>FFlagCount then FFLagCount:=AFlagCount;
refresh;
end;

Function TCadListBox.GetFlag(Index:integer;FlagNumber:byte):boolean;
begin
result:=boolean(test(loword(Items.Objects[index]),FlagNumber));
end;

{Changing a flag value.
 NOTE: FlagNumber goes from 0 to 7, Corresponding Imageindex from 1 to 8}
Procedure TCadListBox.SetFlag(Index:integer;FlagNumber:byte;Flag:Boolean);
var x:integer;
begin
x:=1 shl Flagnumber;
if flag<>getflag(index,FlagNumber) then
Items.objects[Index]:=tobject(makelong(loword(Items.Objects[index]) xor x,0));
refresh;
end;

{Change the margin (=space between pictures)}
procedure TCadListBox.SetMargin(AMargin:byte);
begin
if AMargin<10 then if AMargin<>FMargin then FMargin:=AMargin;
refresh;
end;

Procedure TCadListBox.SetEmptyFlag(AFlag:boolean);
begin
if FShowEmptyFlag<>AFlag then FShowEmptyFlag:=AFlag;
refresh;
end;

{Displaying the bitmaps. Some improvements could be made here}
Procedure TCadListBox.DrawImage(Index, NewIndex : Integer; Rect: TRect);
 Var
 NewBitMap : TBitmap;
 x:integer;
 TheFlag:byte;
 Size:byte;
Begin
  Itemheight:=font.size*2+2;
  NewBitMap := TBitMap.Create;
    With Canvas Do
     Begin
      if assigned(FImageList) then begin
        FimageList.GetBitmap(0, NewBitmap);
        size:=newbitmap.width;
        newbitmap.assign(nil);
        FillRect(Rect);
        for x:=0 to FFLagCount-1 do begin
         TheFlag:=test(loword(Items.Objects[index]),x);
         if x>0 then TheFlag:=TheFlag*(x+1);
         if fShowEmptyFlag then begin
            FimageList.GetBitmap(TheFlag, NewBitmap);
         end else begin
            if theflag>0 then
            FimageList.GetBitmap(TheFlag, NewBitmap);
         end;
         Draw((x*newbitmap.width+x*FMargin)+Rect.Left, Rect.Top+font.size div 2-2, NewBitmap);
         newbitmap.assign(nil);
        end;
         TextOut((FFlagCount*size+(FFLagCount+1)*FMargin)+Rect.Left, Rect.Top ,
         Items.strings[Index]);
       end else begin
         inherited;
       end;
     End;
   NewBitMap.Free;
End;

Procedure TCadListBox.SetImageList(Value : TImageList);
Begin
  If Value <> FimageList Then
    FimageList := Value;
If Not Assigned(FimageList) Then
  FimageList := Nil;
End;

Function TCadListBox.GetImageList : TImageList;
Begin
 Result := FimageList;
End;

Function TCadListBox.GetImageIndex : Integer;
Begin
 Result := FImageIndex;
End;

procedure TCadListBox.DrawItem(Index: Integer; Rect: TRect; State: TOwnerDrawState);
begin
 Inherited;
  DrawImage(Index, FImageIndex, Rect);
end;

{Here the mouse enters the stage}
procedure TCadListBox.MouseDown(Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var b:boolean;
    FlagNumber:byte;
begin
 inherited MouseDown(button,shift,x,y);
 if not assigned(fImageList) then exit;
 if not fToggleFlags then exit;
 if x<fflagcount*(fimagelist.width+fmargin) then begin
  FlagNumber:=(x div (fimagelist.width+fmargin));
  b:=getflag(itemindex,FlagNumber);
     setflag(itemindex,FlagNumber,not b);
 end;
 if assigned(fOnFlagClick) then fOnFlagClick(self,itemindex,flagnumber,not b);
end;

constructor TCadListBox.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  Style := lbOwnerDrawFixed;
  ControlStyle:= ControlStyle + [csAcceptsControls];
  FFlagCount:=1;
end;

Destructor TCadListBox.Destroy;
Begin
 inherited Destroy;
End;

{************************CADCOMBOBOX code starts here************************}
{Adding a new item and a set of flags}
Function TCadComboBox.AddEntry(s:string;flag:byte):integer;
begin
Items.addobject(s,TObject(makelong(flag,0)));
end;

procedure TCadComboBox.SetFlagCount(AFlagCount:byte);
begin
if AFlagCount<9 then if AFlagCount<>FFlagCount then FFLagCount:=AFlagCount;
refresh;
end;

Function TCadComboBox.GetFlag(Index:integer;FlagNumber:byte):boolean;
begin
result:=boolean(test(loword(Items.Objects[index]),FlagNumber));
end;

{Changing a flag value.
 NOTE: FlagNumber goes from 0 to 7, Corresponding Imageindex from 1 to 8}
Procedure TCadComboBox.SetFlag(Index:integer;FlagNumber:byte;Flag:Boolean);
var x:integer;
begin
x:=1 shl Flagnumber;
if flag<>getflag(index,FlagNumber) then
Items.objects[Index]:=tobject(makelong(loword(Items.Objects[index]) xor x,0));
refresh;
end;

{Change the margin (=space between pictures)}
procedure TCadComboBox.SetMargin(AMargin:byte);
begin
if AMargin<10 then if AMargin<>FMargin then FMargin:=AMargin;
refresh;
end;

Procedure TCadComboBox.SetEmptyFlag(AFlag:boolean);
begin
if FShowEmptyFlag<>AFlag then FShowEmptyFlag:=AFlag;
refresh;
end;

{Displaying the bitmaps. Some improvements could be made here}
Procedure TCadComboBox.DrawImage(Index, NewIndex : Integer; Rect: TRect);
 Var
 NewBitMap : TBitmap;
 x:integer;
 TheFlag:byte;
 Size:byte;
Begin
  Itemheight:=font.size*2;
  NewBitMap := TBitMap.Create;
    With Canvas Do
     Begin
      if assigned(FImageList) then begin
        FImageList.GetBitmap(0, NewBitmap);
        size:=newbitmap.width;
        newbitmap.assign(nil);
        FillRect(Rect);
        for x:=0 to FFlagCount-1 do begin
         TheFlag:=test(loword(Items.Objects[index]),x);
         if x>0 then TheFlag:=TheFlag*(x+1);
         if fShowEmptyFlag then begin
            FimageList.GetBitmap(TheFlag, NewBitmap);
         end else begin
            if theflag>0 then
            FimageList.GetBitmap(TheFlag, NewBitmap);
         end;
         Draw((x*newbitmap.height+x*FMargin)+Rect.Left, Rect.Top+font.size div 2-2, NewBitmap);
         newbitmap.assign(nil);
        end;
         TextOut((FFlagCount*size+(FFLagCount+1)*FMargin)+Rect.Left, Rect.Top ,
         Items.strings[Index]);
       end else begin
         inherited;
       end;
     End;
   NewBitMap.Free;
End;

Procedure TCadComboBox.SetImageList(Value : TImageList);
Begin
  If Value <> FimageList Then
    FimageList := Value;
If Not Assigned(FimageList) Then
  FimageList := Nil;
End;

Function TCadComboBox.GetImageList : TImageList;
Begin
 Result := FimageList;
End;

Function TCadComboBox.GetImageIndex : Integer;
Begin
 Result := FImageIndex;
End;

procedure TCadComboBox.DrawItem(Index: Integer; Rect: TRect; State: TOwnerDrawState);
begin
 Inherited;
  DrawImage(Index, FImageIndex, Rect);
end;

{Here the mouse enters the stage}
procedure TCadComboBox.MouseDown(Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var b:boolean;
    FlagNumber:byte;
begin
 inherited MouseDown(button,shift,x,y);
 if not assigned(fImageList) then exit;
 if not fToggleFlags then exit;
 if x<fflagcount*(fimagelist.width+fmargin) then begin
  droppeddown:=false;
  FlagNumber:=(x div (fimagelist.width+fmargin));
  b:=getflag(itemindex,FlagNumber);
     setflag(itemindex,FlagNumber,not b);
 end;
 if assigned(fOnFlagClick) then fOnFlagClick(self,itemindex,flagnumber,not b);
end;

constructor TCadComboBox.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  Style := csOwnerDrawFixed;
  ControlStyle:= ControlStyle + [csAcceptsControls];
  FFLagCount:=1;
end;

Destructor TCadComboBox.Destroy;
Begin
 inherited Destroy;
End;


procedure Register;
begin
  RegisterComponents('Freeware', [TCadListBox]);
  RegisterComponents('Freeware', [TCadComboBox]);
end;

end.
